import 'dart:mirrors';

import 'package:neuro/instance.dart';
import 'package:neuro/neuro.dart';

void autowire(value){
  ClassMirror classMirror = reflectClass(value.runtimeType);
  Map<Symbol, DeclarationMirror> declarations = classMirror.declarations;
  InstanceMirror instanceMirror = reflect(value);

  declarations.forEach((key, value) {
    String name = MirrorSystem.getName(value.simpleName);

    if(name.startsWith("handle")){
      InstanceMirror something = reflect(instanceMirror.getField(key));
      if(something.reflectee is ClosureMirror){
        ClosureMirror closureMirror = something.reflectee;
        MethodMirror methodMirror = closureMirror.function;
        var refl = closureMirror.reflectee;
        if(refl is Function){
          Function function = refl;
          HandlerFunction handlerFunction = (arg) async {
            return function.call(arg);
          };
          neuro.handleDynamic(handlerFunction);
        }
      }
    }
  });
}